require_relative 'lib/helpers'

FactoryBot.define do
  factory :challenge, class: SBF::Client::Challenge do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    status { SBF::Client::Challenge::Status::PENDING }
    end_date { [Date.today + 30, Date.new(Date.today.year, 12, 31)].min }

    after :build do |challenge, evaluator|
      challenge.challenger = build(:challenger) if unpopulated?(evaluator, :challenger)
      challenge.challengee = build(:challengee) if unpopulated?(evaluator, :challengee)
    end
  end
end
