require_relative 'lib/helpers'

FactoryBot.define do
  factory :_base_challenger, class: SBF::Client::Challenger do
    to_create do |it|
      raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save
    end

    initialize_with do
      new(attributes)
    end

    after :build do |challenger, evaluator|
      # TODO: Unable to move to to_create block, to_create block.
      # Entity returns a DataNotProvidedError when referenced in
      # the to_create block. Needs to be fixed when the data model
      # is fixed.
      if unpopulated?(evaluator, :entity)
        event = build(:event)
        participant = create(:shavee, event: event)
        challenger.entity = participant.to_partial
      end
    end
  end

  factory :challenger, class: SBF::Client::Challenger, parent: :_base_challenger do
    is_accepted { true }
  end

  factory :challengee, class: SBF::Client::Challenger, parent: :_base_challenger do
    is_accepted { false }
  end
end
