FactoryBot.define do
  factory :collection, class: SBF::Client::EntityCollection do
    skip_create
  end

  factory :collection_with_error, parent: :collection do
    after :build do |collection, evaluator|
      if evaluator.error
        collection.add_errors(evaluator.error)
      else
        error = SBF::Client::ErrorEntity.new(code: 5007, type: 'BadRequest', details: 'Invalid Request')
        collection.add_errors(error)
      end
      collection.errors_http_code = evaluator.http_code || 400
    end
  end
end
