require_relative 'lib/helpers'

FactoryBot.define do
  factory :contact, class: SBF::Client::CustomContact do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    email { Faker::Internet.email }
    contact_groups { [] }

    after :build do |contact_group, evaluator|
      contact_group.owner = build(:person) if unpopulated?(evaluator, :owner)
    end
  end
end
