require_relative '../lib/helpers'

FactoryBot.define do
  factory :full_donation_participant, class: SBF::Client::Donation::FullParticipant do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    fundraising_goal { 100 }
    shave_time { Time.now.to_s }
    sequence(:display_name) { |n| "Display Name #{n}" }
    model_type { 'person' }

    after :build do |participant, evaluator|
      participant.person = build(:person) if unpopulated?(evaluator, :person)
      participant.send(:totals=, build(:participant_totals)) if unpopulated?(evaluator, :totals)
      participant.send(:rankings=, build(:participant_rankings)) if unpopulated?(evaluator, :rankings)
      participant.roles = build(:participant_roles) if unpopulated?(evaluator, :roles)
      participant.send(:photos=, build(:participant_photos)) if unpopulated?(evaluator, :photos)
      participant.event = build(:event) if unpopulated?(evaluator, :event)
      participant.team = build(:team, event: participant.event) if unpopulated?(evaluator, :team)
      participant.fundraising_page = build(:fundraising_page) if unpopulated?(evaluator, :fundraising_page)
    end
  end
end
