require_relative 'lib/helpers'

FactoryBot.define do
  factory :event_application, class: SBF::Client::EventApplication do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    requested_event_title { "Event Title #{random}" }

    after :build do |event_application, evaluator|
      event_application.requestor = build(:requestor) if unpopulated?(evaluator, :requestor)
    end
  end

  factory :requestor, class: SBF::Client::EventApplication::Requestor do
    skip_create

    initialize_with do
      new(attributes)
    end

    name { Faker::Name.name }

    after :build do |requestor, evaluator|
      requestor.name_pieces = build(:name_pieces) if unpopulated?(evaluator, :name_pieces)
      requestor.email_address = build(:email_address) if unpopulated?(evaluator, :email_address)
      requestor.phone = build(:phone) if unpopulated?(evaluator, :phone)
      requestor.address = build(:address) if unpopulated?(evaluator, :address)
    end
  end
end
