require_relative 'lib/helpers'

FactoryBot.define do
  factory :event_supporter, class: SBF::Client::FullEventSupporter do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    name { "Supporter #{random}" }
    url { Faker::Internet.url }
    sort_order { 1 }

    after :build do |event_supporter, evaluator|
      event_supporter.event = build(:event) if unpopulated?(evaluator, :event)
    end
  end
end
