require_relative 'lib/helpers'

FactoryBot.define do
  factory :fund, class: SBF::Client::FullFund do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    name { Faker::University.greek_organization }
    disabled { false }

    after :build do |fund, evaluator|
      fund.fundraising_page = build(:fundraising_page) if unpopulated?(evaluator, :fundraising_page)
    end
  end
end
