require_relative 'lib/helpers'

FactoryBot.define do
  factory :fundraiser, class: SBF::Client::FullFundraiser do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    status { 'active' }
    fundraising_goal { 100 }
    title { "#{Faker::University.greek_organization} #{random}" }
    start_date { Date.today.to_s }

    after :build do |fundraiser, evaluator|
      fundraiser.event = SBF::Client::Fundraiser::PartialEvent.new(year: Time.now.year) if unpopulated?(evaluator, :event)
      fundraiser.owner = build(:person) if unpopulated?(evaluator, :owner)
      fundraiser.policies = build(:fundraiser_policies) if unpopulated?(evaluator, :policies)
      fundraiser.venue = build(:venue) if unpopulated?(evaluator, :venue)
      fundraiser.owner = build(:full_person) if unpopulated?(evaluator, :owner)
    end
  end
end
