require_relative 'lib/helpers'

FactoryBot.define do
  factory :grant, class: SBF::Client::FullGrant do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    sequence(:name) { |n| "Display Name #{n}" }
    funding_begin_date { Time.now.to_s }
    funding_end_date { Time.now.to_s }
    funding_type { SBF::Client::Grant::PartialFundingType.new(id: 1) }
    web_message { 'This grant supports research staff who' }

    after :build do |grant, evaluator|
      grant.researcher = build(:researcher) if unpopulated?(evaluator, :researcher)
      grant.institution = build(:grant_institution) if unpopulated?(evaluator, :institution)
    end
  end
end
