require_relative 'lib/helpers'

FactoryBot.define do
  factory :grant_institution, class: SBF::Client::Grant::FullInstitution do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    name { 'El Paso Children\'s Hospital' }

    after :build do |grant_institution, evaluator|
      grant_institution.send(:address=, build(:address)) if unpopulated?(evaluator, :address)
    end
  end
end
