require_relative 'lib/helpers'

FactoryBot.define do
  # This is system institutions object
  factory :institution, class: SBF::Client::FullInstitution do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    name { "Institution #{random}" }

    after :build do |institution, evaluator|
      institution.address = build(:address, type: SBF::Client::Address::Type::BUSINESS) if unpopulated?(evaluator, :address)
    end
  end
end
