require_relative 'lib/helpers'

FactoryBot.define do
  # This is the relationship object between the kid and system institutions
  factory :kid_institution, class: SBF::Client::KidInstitution do
    to_create do |it|
      raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save
    end

    initialize_with do
      new(attributes)
    end

    after :build do |kid_institution, evaluator|
      kid_institution.institution = build(:institution) if unpopulated?(evaluator, :institution)
    end

    before :create do |kid_institution, evaluator|
      kid_institution.institution = create(:institution) if unpopulated?(evaluator, :institution)
      kid_institution.kid = create(:kid) if unpopulated?(evaluator, :kid)
    end
  end
end
