require_relative 'lib/helpers'

FactoryBot.define do
  factory :memorial, class: SBF::Client::FullMemorial do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    website_message { 'Memorial ipsum dolor sit amet.' }

    after :build do |memorial, evaluator|
      memorial.photos = build(:memorial_photos) if unpopulated?(evaluator, :photos)
      memorial.tribute = build(:memorial_tribute) if unpopulated?(evaluator, :tribute)
      memorial.third_party_media = build(:third_party_media) if unpopulated?(evaluator, :third_party_media)
      memorial.send(:totals=, build(:memorial_totals)) if unpopulated?(evaluator, :totals)
      memorial.address = build(:address) if unpopulated?(evaluator, :address)
      memorial.tribute = build(:tribute) if unpopulated?(evaluator, :tribute)
    end
  end
end
