require_relative 'lib/helpers'

FactoryBot.define do
  factory :message, class: SBF::Client::Message do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    type { SBF::Client::Message::Type::MEMBERS_COMMUNICATION }
    status { SBF::Client::Message::Status::SENT }
    subject { Faker::Lorem.sentence }
    body { Faker::Lorem.paragraph }

    after :build do |message, evaluator|
      message.to = [build(:message_recipient)] if unpopulated?(evaluator, :to)
    end
  end

  factory :message_recipient, class: SBF::Client::Message::Recipient do
    skip_create

    initialize_with do
      new(attributes)
    end

    status { SBF::Client::Message::Recipient::Status::UNREAD }
    email { Faker::Internet.email }
  end
end
