require_relative 'lib/helpers'

FactoryBot.define do
  factory :organization, class: SBF::Client::FullOrganization do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    status { 'active' }
    name { Faker::Vehicle.manufacture }
    type { SBF::Client::Person::Type::BUSINESS }

    after :build do |organization, evaluator|
      organization.email_addresses = build(:organization_email_addresses) if unpopulated?(evaluator, :email_addresses)
      organization.phone_numbers = build(:organization_phone_numbers) if unpopulated?(evaluator, :phone_numbers)
      organization.contact = build(:organization_contact) if unpopulated?(evaluator, :contact)
      organization.addresses = build(:organization_addresses) if unpopulated?(evaluator, :addresses)
    end
  end

  factory :organization_contact, class: SBF::Client::FullOrganization::ContactName do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |contact, evaluator|
      contact.name_pieces = build(:name_pieces) if unpopulated?(evaluator, :name_pieces)
    end
  end
end
