FactoryBot.define do
  factory :participant_roles, class: SBF::Client::Participant::Roles do
    skip_create

    initialize_with do
      new(attributes)
    end

    transient do
      shavee { true }
      event_support_volunteer { nil }
      individual_fundraiser { nil }
      shavee_recruiter { nil }
      team_captain { nil }
      barber_coordinator { nil }
      organizer { nil }
      lead_organizer { nil }
      treasurer { nil }
      lead_treasurer { nil }
      barber { nil }
    end

    after :build do |roles, evaluator|
      roles.shavee = build(:participant_roles_shavee) if evaluator.shavee
      roles.event_support_volunteer = build(:participant_roles_event_support_volunteer) if evaluator.event_support_volunteer
      roles.individual_fundraiser = build(:participant_roles_individual_fundraiser) if evaluator.individual_fundraiser
      roles.shavee_recruiter = build(:participant_roles_shavee_recruiter) if evaluator.shavee_recruiter
      roles.team_captain = build(:participant_roles_team_captain) if evaluator.team_captain
      roles.barber_coordinator = build(:participant_roles_barber_coordinator) if evaluator.barber_coordinator
      roles.organizer = build(:participant_roles_lead_organizer) if evaluator.lead_organizer
      roles.organizer = build(:participant_roles_organizer) if evaluator.organizer
      roles.treasurer = build(:participant_roles_treasurer) if evaluator.treasurer
      roles.treasurer = build(:participant_roles_lead_treasurer) if evaluator.lead_treasurer
      roles.barber = build(:participant_roles_barber) if evaluator.barber
    end
  end
end
