require_relative '../../lib/helpers'

FactoryBot.define do
  factory :participant_roles_shavee, class: SBF::Client::Participant::Roles::Shavee do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
      role.requested_shavee_packet = false if unpopulated?(evaluator, :requested_shavee_packet)
    end
  end

  factory :participant_roles_event_support_volunteer, class: SBF::Client::Participant::Roles::EventSupportVolunteer do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
    end
  end

  factory :participant_roles_individual_fundraiser, class: SBF::Client::Participant::Roles::IndividualFundraiser do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
    end
  end

  factory :participant_roles_barber_coordinator, class: SBF::Client::Participant::Roles::BarberCoordinator do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
    end
  end

  factory :participant_roles_shavee_recruiter, class: SBF::Client::Participant::Roles::ShaveeRecruiter do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
    end
  end

  factory :participant_roles_team_captain, class: SBF::Client::Participant::Roles::TeamCaptain do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
    end
  end

  factory :participant_roles_organizer, class: SBF::Client::Participant::Roles::Organizer do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
      role.policies = build(:participant_roles_organizer_role_policies) if unpopulated?(evaluator, :policies)
    end
  end

  factory :participant_roles_treasurer, class: SBF::Client::Participant::Roles::Treasurer do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
    end
  end

  factory :participant_roles_barber, class: SBF::Client::Participant::Roles::Barber do
    skip_create

    initialize_with do
      new(attributes)
    end

    after :build do |role, evaluator|
      role.status = SBF::Client::Participant::Roles::Status::ACTIVE if unpopulated?(evaluator, :status)
      role.license = {number: 'License Number', organization: 'License Organization'}
      role.salon = {name: 'Salon Name', phone: {number: '444-333-8888'}}
    end
  end

  factory :participant_roles_lead_treasurer, class: SBF::Client::Participant::Roles::Treasurer do
    skip_create

    initialize_with do
      new(attributes)
    end

    status { SBF::Client::Participant::Roles::Status::ACTIVE }
    is_lead { true }
  end

  factory :participant_roles_lead_organizer, class: SBF::Client::Participant::Roles::Organizer do
    skip_create

    initialize_with do
      new(attributes)
    end

    status { SBF::Client::Participant::Roles::Status::ACTIVE }
    is_lead { true }

    after :build do |organizer, evaluator|
      organizer.policies = build(:participant_roles_organizer_role_policies) if unpopulated?(evaluator, :policies)
    end
  end

  factory :participant_roles_organizer_role_policies, class: SBF::Client::Participant::Roles::Organizer::Policies do
    skip_create

    initialize_with do
      new(attributes)
    end

    agreement_received_date { Time.now.to_s }
    coaches_questionnaire_received_date { Time.now.to_s }
    is_revenue_waiver_accepted { true }
    is_host_agreement_waiver_accepted { true }
  end
end
