require_relative 'lib/helpers'

FactoryBot.define do
  factory :person, class: SBF::Client::FullPerson do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    after :build do |person, evaluator|
      person.email_addresses = build(:person_email_addresses) if unpopulated?(evaluator, :email_addresses)
      person.phone_numbers = build(:person_phone_numbers) if unpopulated?(evaluator, :phone_numbers)
      person.name_pieces = build(:name_pieces) if unpopulated?(evaluator, :name_pieces)
      person.policies = build(:policies) if unpopulated?(evaluator, :policies)
      person.addresses = build(:person_addresses) if unpopulated?(evaluator, :addresses)
      person.status = 'active' if unpopulated?(evaluator, :status)
      person.type = SBF::Client::Person::Type::INDIVIDUAL if unpopulated?(evaluator, :type)
      person.birthday = Faker::Date.birthday(min_age: 19, max_age: 65).to_s if unpopulated?(evaluator, :birthday)
    end
  end
end
