require_relative 'lib/helpers'

FactoryBot.define do
  factory :recurring_gift, class: SBF::Client::FullRecurringGift do
    to_create { |it| raise "Failed to create #{it.class}: #{it.errors.details}" unless it.save }

    initialize_with do
      new(attributes)
    end

    amount { rand(10..100) }
    status { SBF::Client::RecurringGift::Status::PENDING }
    created_at { Date.today }
    last_collected_at { Date.today }
    is_unrecognized { false }

    after :build do |recurring_gift, evaluator|
      recurring_gift.donor = build(:person, status: SBF::Client::Person::Status::ACTIVE) if unpopulated?(evaluator, :donor)
      recurring_gift.payment_details = build(:nonce_payment) if unpopulated?(evaluator, :payment_details)
    end
  end
end
