FactoryBot.define do
  factory :response, class: SBF::Client::Api::Response do
    skip_create

    transient do
      # allow passing in results as an argument
      results { nil }
      total_count { nil }
    end

    after :build do |response, evaluator|
      # Either set data to data passed in as an arg or an empty hash if no data arg
      response.data = evaluator.data || {}

      # Set data[:results] to the arg results
      response.data[:results] = evaluator.results if evaluator.results

      # Set data[:total_count] to the arg total_count
      response.data[:total_count] = evaluator.total_count if evaluator.total_count
    end

    http_code { 200 }
  end

  factory :not_found, class: SBF::Client::Api::Response do
    skip_create

    data { nil }
    http_code { 404 }
  end

  factory :unavailable, class: SBF::Client::Api::Response do
    skip_create

    data { nil }
    http_code { 503 }
  end
end
