require_relative 'lib/helpers'

FactoryBot.define do
  factory :shave_schedule, class: SBF::Client::ShaveSchedule do
    skip_create

    initialize_with do
      new(attributes)
    end

    start_time { '00:00:00' }
    end_time { '23:59:59' }
    number_of_seats { 50 }
    shave_duration_in_minutes { 5 }
  end
end

FactoryBot.define do
  factory :shave_schedule_assignment, class: SBF::Client::ShaveSchedule::ShaveScheduleAssignment do
    skip_create

    initialize_with do
      new(attributes)
    end

    type { SBF::Client::ShaveSchedule::ShaveScheduleAssignment::Type::SHAVEE }
    shave_time { '12:00:00' }

    after :build do |_shave_schedule_assignment, evaluator|
      raise 'participant is required' if unpopulated?(evaluator, :participant)
    end
  end
end
